//---
// fxos-cli: A disassembler and OS reverse-engineering tool
//---

#ifndef FXOS_CLI_H
#define FXOS_CLI_H

#include <fxos/target.h>
#include <fxos/library.h>
#include <string>
#include <vector>

/* Show library */
void show_library(FxOS::Library &library, bool targets, bool asmtables);

/* Print general information on an OS file */
void os_info(FxOS::Target &target);

/* Disassemble */
int disassembly(FxOS::Library &library, FxOS::Target &target, char const *ref,
	std::vector<std::string> passes);

#endif /* FXOS_CLI_H */
